Package com.ocient.jdbc.proto

# Interface PlanProtocol.WindowOperatorOrBuilder

All Superinterfaces:
  `com.google.protobuf.MessageLiteOrBuilder`, `com.google.protobuf.MessageOrBuilder`

All Known Implementing Classes:
  `PlanProtocol.WindowOperator`, `PlanProtocol.WindowOperator.Builder`

Enclosing class:
  PlanProtocol

    public static interface PlanProtocol.WindowOperatorOrBuilder
    extends com.google.protobuf.MessageOrBuilder

## Method Summary

Modifier and Type | Method | Description
--- | --- | ---
`double` | `getConstFloatArgs​(int index)` | For functions that take a constant floating point argument - they are here - there's an entry for every op even if it isn't used
`int` | `getConstFloatArgsCount()` | For functions that take a constant floating point argument - they are here - there's an entry for every op even if it isn't used
`List<Double>` | `getConstFloatArgsList()` | For functions that take a constant floating point argument - they are here - there's an entry for every op even if it isn't used
`long` | `getConstIntArgs​(int index)` | For functions that take a constant integer argument - they are here - there's an entry for every op even if it isn't used
`int` | `getConstIntArgsCount()` | For functions that take a constant integer argument - they are here - there's an entry for every op even if it isn't used
`List<Long>` | `getConstIntArgsList()` | For functions that take a constant integer argument - they are here - there's an entry for every op even if it isn't used
`boolean` | `getDirections​(int index)` | The directions for each sort col - true = ascending
`int` | `getDirectionsCount()` | The directions for each sort col - true = ascending
`List<Boolean>` | `getDirectionsList()` | The directions for each sort col - true = ascending
`PlanProtocol.FrameSpec` | `getFrames​(int index)` | The frame specification for each op, in the same order
`int` | `getFramesCount()` | The frame specification for each op, in the same order
`List<PlanProtocol.FrameSpec>` | `getFramesList()` | The frame specification for each op, in the same order
`PlanProtocol.FrameSpecOrBuilder` | `getFramesOrBuilder​(int index)` | The frame specification for each op, in the same order
`List<? extends PlanProtocol.FrameSpecOrBuilder>` | `getFramesOrBuilderList()` | The frame specification for each op, in the same order

`String`

`getInputCols​(int index)`

The columns to perform each aggregation on (for operations that take a normal column argument) In the same order as ops (and same size) The following operations have no input, so any value in those positions is garbage WINDOW_OP_COUNT_STAR WINDOW_OP_RANK WINDOW_OP_DENSE_RANK WINDOW_OP_ROW_NUMBER WINDOW_OP_FIRST_VALUE WINDOW_OP_LAST_VALUE WINDOW_OP_CUME_DIST WINDOW_OP_PERCENT_RANK Additionally these operations only have constant input values, not a column input - so there is nothing here WINDOW_OP_NTH_VALUE WINDOW_OP_NTILE

`com.google.protobuf.ByteString`

`getInputColsBytes​(int index)`

The columns to perform each aggregation on (for operations that take a normal column argument) In the same order as ops (and same size) The following operations have no input, so any value in those positions is garbage WINDOW_OP_COUNT_STAR WINDOW_OP_RANK WINDOW_OP_DENSE_RANK WINDOW_OP_ROW_NUMBER WINDOW_OP_FIRST_VALUE WINDOW_OP_LAST_VALUE WINDOW_OP_CUME_DIST WINDOW_OP_PERCENT_RANK Additionally these operations only have constant input values, not a column input - so there is nothing here WINDOW_OP_NTH_VALUE WINDOW_OP_NTILE

`int`

`getInputColsCount()`

The columns to perform each aggregation on (for operations that take a normal column argument) In the same order as ops (and same size) The following operations have no input, so any value in those positions is garbage WINDOW_OP_COUNT_STAR WINDOW_OP_RANK WINDOW_OP_DENSE_RANK WINDOW_OP_ROW_NUMBER WINDOW_OP_FIRST_VALUE WINDOW_OP_LAST_VALUE WINDOW_OP_CUME_DIST WINDOW_OP_PERCENT_RANK Additionally these operations only have constant input values, not a column input - so there is nothing here WINDOW_OP_NTH_VALUE WINDOW_OP_NTILE

`List<String>`

`getInputColsList()`

The columns to perform each aggregation on (for operations that take a normal column argument) In the same order as ops (and same size) The following operations have no input, so any value in those positions is garbage WINDOW_OP_COUNT_STAR WINDOW_OP_RANK WINDOW_OP_DENSE_RANK WINDOW_OP_ROW_NUMBER WINDOW_OP_FIRST_VALUE WINDOW_OP_LAST_VALUE WINDOW_OP_CUME_DIST WINDOW_OP_PERCENT_RANK Additionally these operations only have constant input values, not a column input - so there is nothing here WINDOW_OP_NTH_VALUE WINDOW_OP_NTILE

`boolean` | `getLimit1()` | Is there an immediate following limit 1?
`boolean` | `getNullsFirst​(int index)` | `repeated bool nulls_first = 12;`
`int` | `getNullsFirstCount()` | `repeated bool nulls_first = 12;`
`List<Boolean>` | `getNullsFirstList()` | `repeated bool nulls_first = 12;`
`PlanProtocol.WindowOperator.WindowOp` | `getOps​(int index)` | The aggregation operations to perform
`int` | `getOpsCount()` | The aggregation operations to perform
`List<PlanProtocol.WindowOperator.WindowOp>` | `getOpsList()` | The aggregation operations to perform
`int` | `getOpsValue​(int index)` | The aggregation operations to perform
`List<Integer>` | `getOpsValueList()` | The aggregation operations to perform
`String` | `getOutputCols​(int index)` | The name to give to the columns created by each aggregation operation
`com.google.protobuf.ByteString` | `getOutputColsBytes​(int index)` | The name to give to the columns created by each aggregation operation
`int` | `getOutputColsCount()` | The name to give to the columns created by each aggregation operation
`List<String>` | `getOutputColsList()` | The name to give to the columns created by each aggregation operation
`String` | `getOutputColsTypes​(int index)` | The types for the outputCols, in the same order
`com.google.protobuf.ByteString` | `getOutputColsTypesBytes​(int index)` | The types for the outputCols, in the same order
`int` | `getOutputColsTypesCount()` | The types for the outputCols, in the same order
`List<String>` | `getOutputColsTypesList()` | The types for the outputCols, in the same order
`String` | `getPartitioningCols​(int index)` | Partitioning columns
`com.google.protobuf.ByteString` | `getPartitioningColsBytes​(int index)` | Partitioning columns
`int` | `getPartitioningColsCount()` | Partitioning columns
`List<String>` | `getPartitioningColsList()` | Partitioning columns
`String` | `getSortKeys​(int index)` | The sort columns - already includes partitioning cols if any
`com.google.protobuf.ByteString` | `getSortKeysBytes​(int index)` | The sort columns - already includes partitioning cols if any
`int` | `getSortKeysCount()` | The sort columns - already includes partitioning cols if any
`List<String>` | `getSortKeysList()` | The sort columns - already includes partitioning cols if any

### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

`isInitialized`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDefaultInstanceForType, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

## Method Details

### getPartitioningColsList

List<String> getPartitioningColsList()

    Partitioning columns

`repeated string partitioning_cols = 1;`

### getPartitioningColsCount

int getPartitioningColsCount()

    Partitioning columns

`repeated string partitioning_cols = 1;`

### getPartitioningCols

String getPartitioningCols​(int index)

    Partitioning columns

`repeated string partitioning_cols = 1;`

### getPartitioningColsBytes

com.google.protobuf.ByteString getPartitioningColsBytes​(int index)

    Partitioning columns

`repeated string partitioning_cols = 1;`

### getSortKeysList

List<String> getSortKeysList()

    The sort columns - already includes partitioning cols if any

`repeated string sortKeys = 2;`

### getSortKeysCount

int getSortKeysCount()

    The sort columns - already includes partitioning cols if any

`repeated string sortKeys = 2;`

### getSortKeys

String getSortKeys​(int index)

    The sort columns - already includes partitioning cols if any

`repeated string sortKeys = 2;`

### getSortKeysBytes

com.google.protobuf.ByteString getSortKeysBytes​(int index)

    The sort columns - already includes partitioning cols if any

`repeated string sortKeys = 2;`

### getDirectionsList

List<Boolean> getDirectionsList()

    The directions for each sort col - true = ascending

`repeated bool directions = 3;`

### getDirectionsCount

int getDirectionsCount()

    The directions for each sort col - true = ascending

`repeated bool directions = 3;`

### getDirections

boolean getDirections​(int index)

    The directions for each sort col - true = ascending

`repeated bool directions = 3;`

### getOpsList

List<PlanProtocol.WindowOperator.WindowOp> getOpsList()

    The aggregation operations to perform

`repeated .xg.db.sqlPlans.WindowOperator.WindowOp ops = 4;`

### getOpsCount

int getOpsCount()

    The aggregation operations to perform

`repeated .xg.db.sqlPlans.WindowOperator.WindowOp ops = 4;`

### getOps

PlanProtocol.WindowOperator.WindowOp getOps​(int index)

    The aggregation operations to perform

`repeated .xg.db.sqlPlans.WindowOperator.WindowOp ops = 4;`

### getOpsValueList

List<Integer> getOpsValueList()

    The aggregation operations to perform

`repeated .xg.db.sqlPlans.WindowOperator.WindowOp ops = 4;`

### getOpsValue

int getOpsValue​(int index)

    The aggregation operations to perform

`repeated .xg.db.sqlPlans.WindowOperator.WindowOp ops = 4;`

### getInputColsList

List<String> getInputColsList()

    The columns to perform each aggregation on (for operations that take a normal column argument)
    In the same order as ops (and same size)
    The following operations have no input, so any value in those positions is garbage
    WINDOW_OP_COUNT_STAR
    WINDOW_OP_RANK
    WINDOW_OP_DENSE_RANK
    WINDOW_OP_ROW_NUMBER
    WINDOW_OP_FIRST_VALUE
    WINDOW_OP_LAST_VALUE
    WINDOW_OP_CUME_DIST
    WINDOW_OP_PERCENT_RANK
    Additionally these operations only have constant input values, not a column input - so there is nothing here
    WINDOW_OP_NTH_VALUE
    WINDOW_OP_NTILE

`repeated string inputCols = 5;`

### getInputColsCount

int getInputColsCount()

    The columns to perform each aggregation on (for operations that take a normal column argument)
    In the same order as ops (and same size)
    The following operations have no input, so any value in those positions is garbage
    WINDOW_OP_COUNT_STAR
    WINDOW_OP_RANK
    WINDOW_OP_DENSE_RANK
    WINDOW_OP_ROW_NUMBER
    WINDOW_OP_FIRST_VALUE
    WINDOW_OP_LAST_VALUE
    WINDOW_OP_CUME_DIST
    WINDOW_OP_PERCENT_RANK
    Additionally these operations only have constant input values, not a column input - so there is nothing here
    WINDOW_OP_NTH_VALUE
    WINDOW_OP_NTILE

`repeated string inputCols = 5;`

### getInputCols

String getInputCols​(int index)

    The columns to perform each aggregation on (for operations that take a normal column argument)
    In the same order as ops (and same size)
    The following operations have no input, so any value in those positions is garbage
    WINDOW_OP_COUNT_STAR
    WINDOW_OP_RANK
    WINDOW_OP_DENSE_RANK
    WINDOW_OP_ROW_NUMBER
    WINDOW_OP_FIRST_VALUE
    WINDOW_OP_LAST_VALUE
    WINDOW_OP_CUME_DIST
    WINDOW_OP_PERCENT_RANK
    Additionally these operations only have constant input values, not a column input - so there is nothing here
    WINDOW_OP_NTH_VALUE
    WINDOW_OP_NTILE

`repeated string inputCols = 5;`

### getInputColsBytes

com.google.protobuf.ByteString getInputColsBytes​(int index)

    The columns to perform each aggregation on (for operations that take a normal column argument)
    In the same order as ops (and same size)
    The following operations have no input, so any value in those positions is garbage
    WINDOW_OP_COUNT_STAR
    WINDOW_OP_RANK
    WINDOW_OP_DENSE_RANK
    WINDOW_OP_ROW_NUMBER
    WINDOW_OP_FIRST_VALUE
    WINDOW_OP_LAST_VALUE
    WINDOW_OP_CUME_DIST
    WINDOW_OP_PERCENT_RANK
    Additionally these operations only have constant input values, not a column input - so there is nothing here
    WINDOW_OP_NTH_VALUE
    WINDOW_OP_NTILE

`repeated string inputCols = 5;`

### getOutputColsList

List<String> getOutputColsList()

    The name to give to the columns created by each aggregation operation

`repeated string outputCols = 6;`

### getOutputColsCount

int getOutputColsCount()

    The name to give to the columns created by each aggregation operation

`repeated string outputCols = 6;`

### getOutputCols

String getOutputCols​(int index)

    The name to give to the columns created by each aggregation operation

`repeated string outputCols = 6;`

### getOutputColsBytes

com.google.protobuf.ByteString getOutputColsBytes​(int index)

    The name to give to the columns created by each aggregation operation

`repeated string outputCols = 6;`

### getOutputColsTypesList

List<String> getOutputColsTypesList()

    The types for the outputCols, in the same order

`repeated string outputColsTypes = 7;`

### getOutputColsTypesCount

int getOutputColsTypesCount()

    The types for the outputCols, in the same order

`repeated string outputColsTypes = 7;`

### getOutputColsTypes

String getOutputColsTypes​(int index)

    The types for the outputCols, in the same order

`repeated string outputColsTypes = 7;`

### getOutputColsTypesBytes

com.google.protobuf.ByteString getOutputColsTypesBytes​(int index)

    The types for the outputCols, in the same order

`repeated string outputColsTypes = 7;`

### getFramesList

List<PlanProtocol.FrameSpec> getFramesList()

    The frame specification for each op, in the same order

`repeated .xg.db.sqlPlans.FrameSpec frames = 8;`

### getFrames

PlanProtocol.FrameSpec getFrames​(int index)

    The frame specification for each op, in the same order

`repeated .xg.db.sqlPlans.FrameSpec frames = 8;`

### getFramesCount

int getFramesCount()

    The frame specification for each op, in the same order

`repeated .xg.db.sqlPlans.FrameSpec frames = 8;`

### getFramesOrBuilderList

List<? extends PlanProtocol.FrameSpecOrBuilder> getFramesOrBuilderList()

    The frame specification for each op, in the same order

`repeated .xg.db.sqlPlans.FrameSpec frames = 8;`

### getFramesOrBuilder

PlanProtocol.FrameSpecOrBuilder getFramesOrBuilder​(int index)

    The frame specification for each op, in the same order

`repeated .xg.db.sqlPlans.FrameSpec frames = 8;`

### getConstIntArgsList

List<Long> getConstIntArgsList()

    For functions that take a constant integer argument - they are here - there's an entry for every op even if it isn't used

`repeated int64 constIntArgs = 9;`

### getConstIntArgsCount

int getConstIntArgsCount()

    For functions that take a constant integer argument - they are here - there's an entry for every op even if it isn't used

`repeated int64 constIntArgs = 9;`

### getConstIntArgs

long getConstIntArgs​(int index)

    For functions that take a constant integer argument - they are here - there's an entry for every op even if it isn't used

`repeated int64 constIntArgs = 9;`

### getConstFloatArgsList

List<Double> getConstFloatArgsList()

    For functions that take a constant floating point argument - they are here - there's an entry for every op even if it isn't used

`repeated double constFloatArgs = 10;`

### getConstFloatArgsCount

int getConstFloatArgsCount()

    For functions that take a constant floating point argument - they are here - there's an entry for every op even if it isn't used

`repeated double constFloatArgs = 10;`

### getConstFloatArgs

double getConstFloatArgs​(int index)

    For functions that take a constant floating point argument - they are here - there's an entry for every op even if it isn't used

`repeated double constFloatArgs = 10;`

### getLimit1

boolean getLimit1()

    Is there an immediate following limit 1?

`bool limit1 = 11;`

### getNullsFirstList

List<Boolean> getNullsFirstList()
`repeated bool nulls_first = 12;`

### getNullsFirstCount

int getNullsFirstCount()
`repeated bool nulls_first = 12;`

### getNullsFirst

boolean getNullsFirst​(int index)
`repeated bool nulls_first = 12;`